#if !defined(_SEModule_h_inc_)
#define _SEModule_h_inc_

#include "SEModule_base.h"

class Module : public SEModule_base
{
public:
	Module(seaudioMasterCallback2 seaudioMaster, void *p_resvd1);
	~Module();

	static bool getModuleProperties (SEModuleProperties* properties); 
	virtual bool getPinProperties (long index, SEPinProperties* properties);
	void SE_CALLING_CONVENTION sub_process(long buffer_offset, long sampleFrames );
	void OnPlugStateChange(SEPin *pin);
	virtual void OnMidiData( unsigned long p_clock, unsigned long midi_msg, short pin_id);
	void open();
private:
float *input1_buffer;
float *output1_buffer;
short note;
short vel;
short vdif;
short OU;
bool trigger;
int stat;// = midi_msg & 0xf0;
int b2;// = ( midi_msg / 0x100 ) & 0xff;//note
int b3;// = ( midi_msg / 0x10000 ) & 0xff;//vel

float *tr;
long offset;

#define PN_MIDI_IN 0
#define PN_ON 1
#define PN_NOTETRIG 2
#define PN_VEL 3
#define PN_MIDITRIG 4
#define PN_OU 5

#define SYSTEM_MSG		        0xF0
#define NOTE_OFF                0x80
#define NOTE_ON                 0x90

struct LL
{
char thisSEM[100];
};
struct BB
{
	char buffer[1000];
};
};
#endif
